include \asm\win32.inc

.data
input_dn INPUT <INPUT_KEYBOARD,<<0,0,0,0,0>>>
input_up INPUT <INPUT_KEYBOARD,<<0,0,KEYEVENTF_KEYUP,0,0>>>
frmtitle BYTE 'MPCntrl',0

.code
ontimer:    push ebx
            mov ebx,GetAsyncKeyState
            push VK_ADD
            call ebx
            test eax,eax
            mov al,VK_MEDIA_NEXT_TRACK
            jnz @f
            push VK_SUBTRACT
            call ebx
            test eax,eax
            mov al,VK_MEDIA_PREV_TRACK
            jnz @f
            push VK_DIVIDE
            call ebx
            test eax,eax
            mov al,VK_MEDIA_PLAY_PAUSE
            jz ontimer_
@@:         movzx eax,al
            mov edx,offset input_dn
            mov (INPUT ptr [edx]).ki.wVk,ax
            mov (INPUT ptr [edx]).ki.wVk + sizeof INPUT,ax
            invoke SendInput,2,edx,sizeof INPUT
ontimer_:   pop ebx
            ret

frmproc:    ; proc public hwnd:DWORD,msg:DWORD,wparam:DWORD,lparam:DWORD
    mov edx,[esp+4]
    mov eax,[esp+8]

    cmp eax,WM_CREATE
    jnz @f
      push 0
      push 100
      push 1
      push edx
      call SetTimer
      jmp fpdone
    
@@: cmp eax,WM_CLOSE
    jnz @f
      INVOKE PostQuitMessage,0
      jmp fpdone

@@: cmp eax,WM_DESTROY
    jnz @f
      INVOKE KillTimer,edx,1
      jmp fpdone

@@: cmp eax,WM_TIMER
    jnz @f
     call ontimer
fpdone:
    sub eax,eax
    ret 16

@@: jmp DefWindowProc


public start
start:
    call GetCurrentProcess
    sub ebx,ebx
    mov esi,eax
    mov edi,offset frmtitle
    mov ebp,32512
    
    push ebx                ;hIconSm
    push edi                ;lpszClassName
    push ebx                ;lpszMenuName
    push 1                  ;hbrBackground
    push ebp
    push ebx
    call LoadCursor
    push eax                ;hCursor
    push ebp
    push ebx
    call LoadIcon
    push eax                ;hIcon
    push esi                ;hInstance
    push ebx                ;cbWndExtra
    push ebx                ;cbClsExtra
    push OFFSET frmproc     ;lpfnWndProc
    push 3                  ;style
    push 48                 ;cbSize
    push esp
    call RegisterClassEx
    add esp,48
    test eax,eax
    jz done
    push ebx                ;lpParam
    push esi                ;hInstance
    push ebx                ;hMenu
    push ebx                ;hwndParent
    push 80                 ;nHeight
    push 127                ;nWidth
    push 8                  ;Y
    push 8                  ;X
    push (WS_VISIBLE or WS_BORDER or WS_CAPTION or \
          WS_MINIMIZEBOX or WS_CLIPCHILDREN or WS_SYSMENU)
    push edi                ;lpWindowName
    push edi                ;lpClassName
    push ebx                ;dwExStyle
    call CreateWindowEx
    test eax,eax
    jz done

    sub esp,sizeof MSG
    mov esi,esp
  msgloop:
    INVOKE GetMessage,esi,ebx,ebx,ebx
    test eax,eax
    jz done
    INVOKE DispatchMessage,esi
    jmp msgloop
  done:
    push eax
    jmp ExitProcess

end start
